//+------------------------------------------------------------------+
//|                                                    mfi color mtf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern double          MfiPeriod       = 14;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";

//
//
//
//
//

double mfi[];
double mfiUa[];
double mfiUb[];
double slope[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,mfiUa); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,mfiUb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,mfi);
   SetIndexBuffer(3,slope);
   
   //
   //
   //
   //
   //
    
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(TimeFrame)+ " Mfi ");
   return(0);
}
int deinit(){ return(0);}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars)  { mfiUa[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     for(i=limit; i>=0; i--)
     {  
        double PosMF = 0.0;
        double NegMF = 0.0;
        double CurTP = (High[i]+Low[i]+Close[i])/3;
        double PreTP = (High[i+1]+Low[i+1]+Close[i+1])/3;   
      
        for(int j=0; j < MfiPeriod; j++)
        {
         
          if(CurTP > PreTP) PosMF += Volume[i+j]*CurTP;  
          else
          {
          if(CurTP < PreTP) NegMF += Volume[i+j]*CurTP;
          }
           CurTP = PreTP;      
        }
         
        //
        //
        //
        //
        //
      
        if(NegMF  != 0.0)      
             mfi[i]  = 100*(PosMF/NegMF);
        else mfi[i]  = 100; 
    
        mfiUa[i] = EMPTY_VALUE;
        mfiUb[i] = EMPTY_VALUE;
        slope[i] = slope[i+1];
        if (mfi[i] > mfi[i+1]) slope[i] =  1;
        if (mfi[i] < mfi[i+1]) slope[i] = -1;
        if (slope[i]== 1) mfiUa[i] = 1;
        if (slope[i]==-1) mfiUb[i] = 1;
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1; 
        if (slope[whichBar] != slope[whichBar+1])
        {
           if (slope[whichBar] ==  1) doAlert(whichBar,"up");
           if (slope[whichBar] == -1) doAlert(whichBar,"down");
        }
      }
      return(0);
      }
     
      //
      //
      //
      //
      //
   
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
      for(i=limit; i>=0; i--)
      {  
         int y = iBarShift(NULL,TimeFrame,Time[i]);
            slope[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MfiPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
            mfiUa[i] = EMPTY_VALUE;
            mfiUb[i] = EMPTY_VALUE; 
            if (slope[i]== 1) mfiUa[i] = 1;
            if (slope[i]==-1) mfiUb[i] = 1; 
       }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Money Flow Index changed direction to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Money Flow Index "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}




  